use super::number::Number;


/// A trait that defines what is required to be considered
/// a Real number. [List of types of numbers][1]
///
/// [1]: https://en.wikipedia.org/wiki/List_of_types_of_numbers
trait Real : Number
{
}


// Create a macro to ease typing and reading.
/// A macro to make implementing the trait easier for all the
/// base float types in rust.
macro_rules! real_trait_impl
{
   ($traitName: ident for $($varType: ty)*) =>
   ($(
      impl Real for $varType
      {
      }
   )*)
}


// Implement the trait for the types that are Real numbers.
real_trait_impl!(Real for f32 f64);
